#include <iostream>

using namespace std;

const int N = 505;
int n,m;
int mat[N][N];

bool krstic(int i, int j)
{
    if(mat[i][j] != 1) return false;
    if(mat[i-1][j] != 1) return false;
    if(mat[i+1][j] != 1) return false;
    if(mat[i][j-1] != 1) return false;
    if(mat[i][j+1] != 1) return false;
    return true;
}

void oboj(int i, int j, int c)
{
    mat[i][j] = c;
    mat[i+1][j] = c;
    mat[i-1][j] = c;
    mat[i][j+1] = c;
    mat[i][j-1] = c;
}

int main()
{
    int t;
    scanf("%i",&t);
    for(int _i = 0; _i < t; _i++)
    {
        scanf("%i %i",&n,&m);
        for(int i = 0; i < n; i++)
            for(int j = 0; j < m; j++)
                scanf("%i",&mat[i][j]);
        int col = 2;
        for(int i = 1; i < n - 1; i++)
            for(int j = 1; j < m - 1; j++)
                if(krstic(i,j))
                    oboj(i,j,col++);
        bool moze = true;
        for(int i = 0; i < n; i++)
            for(int j = 0; j < m; j++)
                if(mat[i][j] == 1) moze = false;
        if(!moze) printf("-1\n");
        else
        {
            for(int i = 0; i < n; i++)
                for(int j = 0; j < m; j++)
                    printf("%i%c",mat[i][j]?mat[i][j]-1:0, j == n - 1?'\n':' ');
        }
    }
    return 0;
}
